/* Cache.h b1.1    Definitions for cache routines */

/*
	This is part of ODS2 written by Paul Nankervis,
	email address:  Paulnank@au1.ibm.com

	ODS2 is distributed freely for all members of the
	VMS community to use. However all derived works
	must maintain comments in their source to acknowledge
	the contibution of the original author.
*/

#ifndef CACHE_LOADED
#define CACHE_LOADED 1
struct CACHE {
    struct CACHE **parent;
    struct CACHE *left;
    struct CACHE *right;
    struct CACHE *nxtlru;
    struct CACHE *lstlru;
    struct CACHE *(*getproxy) (struct CACHE * cacheobj);
    int refcount;
    unsigned touches;
};

void cachetouch(struct CACHE *cacheobj);
unsigned cacheuntouch(struct CACHE *cacheobj,int reuse);
struct CACHE *cachefree(struct CACHE *cacheobj,int refcount);
struct CACHE *cachemake(struct CACHE **parent,unsigned length);
void *cachesearch(void **root,unsigned keylen,void *key,
		  int (*compare) (unsigned keylen,void *key,void *node),
		  unsigned *createsize);

#endif
