/* Device.c b1.1  Module to remember and find devices...*/

/*
	This is part of ODS2 written by Paul Nankervis,
	email address:  Paulnank@au1.ibm.com

	ODS2 is distributed freely for all members of the
	VMS community to use. However all derived works
	must maintain comments in their source to acknowledge
	the contibution of the original author.
*/

/* Should have mechanism to return actual device name... */

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <ctype.h>
#include "ssdef.h"
#include "access.h"
#include "phy.h"


int devcmp(unsigned keylen,void *key,void *node)
{
    register struct DEV *devnode = (struct DEV *) node;
    register cmp = keylen - devnode->devlen;
    if (cmp == 0) {
	register unsigned len = keylen;
	register char *keynam = (char *) key;
	register char *devnam = devnode->devnam;
	while (len-- > 0) {
	    cmp = toupper(*keynam++) - toupper(*devnam++);
	    if (cmp != 0) break;
	}
    }
    return cmp;
}

struct DEV *dev_root = NULL;

unsigned device_lookup(unsigned devlen,char *devnam,int create,struct DEV **retdev)
{
    register struct DEV *dev;
    register unsigned sts,devsiz = 0;
    unsigned devcreate = 0;
    while (devsiz < devlen) {
	if (devnam[devsiz++] == ':') {
	    break;
	}
    }
    if (create) devcreate = sizeof(struct DEV) + devsiz;
    dev = (struct DEV *) cachesearch((void **) &dev_root,devsiz,
				     (void *) devnam,devcmp,&devcreate);
    if (dev == NULL) {
	if (create) {
	    sts = SS$_INSFMEM;
	} else {
	    sts = SS$_NOSUCHDEV;
	}
    } else {
	*retdev = dev;
	if (create && (devcreate == 0)) {
	    memcpy(dev->devnam,devnam,dev->devlen = devsiz);
	    dev->devnam[devsiz] = '\0';
	    sts = phyio_init(devsiz,devnam,&dev->handle);
	    if ((sts & 1) == 0) {
		cachefree((struct CACHE *) dev,1);
	    }
	} else {
	    sts = 1;
	}
    }
    return sts;
}
